/*
This file is auto-generated by OWL2Go (https://git.rwth-aachen.de/acs/public/ontology/owl/owl2go).

Copyright 2020 Institute for Automation of Complex Power Systems,
E.ON Energy Research Center, RWTH Aachen University

This project is licensed under either of
- Apache License, Version 2.0
- MIT License
at your option.

Apache License, Version 2.0:

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

MIT License:

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package ontology

import (
	"errors"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/rdf"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/owl"
	"strings"
)

// SarefSwitchOnService A type of service that represents an on/off function to the network
type SarefSwitchOnService interface {
	SarefService
	IsSarefSwitchOnService() bool // indicates base class
}

// sSarefSwitchOnService A type of service that represents an on/off function to the network
type sSarefSwitchOnService struct {
	propCommon
	propSarefIsOfferedByBaseSarefDeviceTypeSarefLightSwitchMultipleSarefLightSwitch
	propSarefRepresentsBaseSarefFunctionTypeSarefOnOffFunctionMultipleSarefOnOffFunction
}

// NewSarefSwitchOnService creates a new SarefSwitchOnService
func (mod *Model) NewSarefSwitchOnService(iri string) (ret SarefSwitchOnService, err error) {
	if mod.Exist(iri) {
		err = errors.New("Resource already exists")
		return
	}
	res := &sSarefSwitchOnService{}
	pc := propCommon{iri: iri, typ: "SarefSwitchOnService", model: mod}
	res.propCommon = pc
	mod.addSarefSwitchOnService(res)
	res.makeMaps()
	ret = res
	return
}

// makeMaps creates initiliazes maps
func (res *sSarefSwitchOnService) makeMaps() {
	res.sarefIsOfferedBy = make(map[string]SarefLightSwitch)
	res.sarefRepresents = make(map[string]SarefOnOffFunction)
	return
}

// addSarefSwitchOnService adds SarefSwitchOnService to model
func (mod *Model) addSarefSwitchOnService(res SarefSwitchOnService) {
	mod.mSarefSwitchOnService[res.IRI()] = res
	mod.addSarefService(res)
	return
}

// SarefSwitchOnService returns all resources with given prefix
func (mod *Model) SarefSwitchOnService(prefix string) (res []SarefSwitchOnService) {
	for i := range mod.mSarefSwitchOnService {
		if strings.HasPrefix(i, prefix) {
			res = append(res, mod.mSarefSwitchOnService[i])
		}
	}
	return
}

// RemoveObject deletes all its references in this object
func (res *sSarefSwitchOnService) RemoveObject(obj owl.Thing, prop string) {
	switch prop {
	case "https://w3id.org/saref#isOfferedBy":
		if v, ok := obj.(SarefDevice); ok {
			res.DelSarefIsOfferedBy(v)
		}
	case "https://w3id.org/saref#represents":
		res.propSarefRepresentsBaseSarefFunctionTypeSarefOnOffFunctionMultipleSarefOnOffFunction.removeObject(obj)
	default:
	}
	return
}

// isSarefSwitchOnService indicates base class
func (res *sSarefSwitchOnService) IsSarefSwitchOnService() bool {
	return true
}

// isSarefService indicates base class
func (res *sSarefSwitchOnService) IsSarefService() bool {
	return true
}

// SetSarefIsOfferedBy is setter of A relationship between a service and a device that offers the service
func (res *sSarefSwitchOnService) SetSarefIsOfferedBy(in []SarefDevice) (err error) {
	temp := res.sarefIsOfferedBy
	res.sarefIsOfferedBy = make(map[string]SarefLightSwitch)
	for i := range temp {
		temp[i].DelSarefOffers(res)
	}
	err = res.AddSarefIsOfferedBy(in...)
	return
}

// AddSarefIsOfferedBy adds A relationship between a service and a device that offers the service
func (res *sSarefSwitchOnService) AddSarefIsOfferedBy(in ...SarefDevice) (err error) {
	for i := range in {
		if v, ok := in[i].(SarefLightSwitch); ok {
			if _, ok := res.sarefIsOfferedBy[v.IRI()]; !ok {
				res.sarefIsOfferedBy[v.IRI()] = v
				v.AddSarefOffers(res)
			}
			continue
		}
		err = errors.New("Wrong SarefLightSwitch type. Allowed types are [SarefLightSwitch, ]")
	}
	return
}

// DelSarefIsOfferedBy deletes A relationship between a service and a device that offers the service
func (res *sSarefSwitchOnService) DelSarefIsOfferedBy(in ...SarefDevice) (err error) {
	for i := range in {
		if v, ok := in[i].(SarefLightSwitch); ok {
			if _, ok := res.sarefIsOfferedBy[v.IRI()]; !ok {
				delete(res.sarefIsOfferedBy, v.IRI())
				v.DelSarefOffers(res)
			}
			continue
		}
		err = errors.New("Wrong SarefLightSwitch type. Allowed types are [SarefLightSwitch, ]")
	}
	return
}

// InitFromNode initializes the resource from a graph node
func (res *sSarefSwitchOnService) InitFromNode(node *rdf.Node) (err error) {
	for i := range node.Edge {
		res.propsInit(node.Edge[i])
	}
	return
}

// propsInit initializes the property from a graph node
func (res *sSarefSwitchOnService) propsInit(pred *rdf.Edge) (err error) {
	switch pred.Pred.String() {
	case "https://w3id.org/saref#isOfferedBy":
		if obj, ok := res.model.mSarefDevice[pred.Object.Term.String()]; ok {
			res.AddSarefIsOfferedBy(obj)
		}
	case "https://w3id.org/saref#represents":
		res.propSarefRepresentsBaseSarefFunctionTypeSarefOnOffFunctionMultipleSarefOnOffFunction.init(res.model, pred.Object.Term.String())
	default:
	}
	return
}

// ToGraph creates a new owl graph node and adds it to the graph
func (res *sSarefSwitchOnService) ToGraph(g *rdf.Graph) {
	node := owl.AddObjectToGraph(g, "https://w3id.org/saref#SwitchOnService", res)
	res.propsToGraph(node, g)
	return
}

// propsToGraph adds all properties to the graph
func (res *sSarefSwitchOnService) propsToGraph(node *rdf.Node, g *rdf.Graph) {
	res.propSarefIsOfferedByBaseSarefDeviceTypeSarefLightSwitchMultipleSarefLightSwitch.toGraph(node, g)
	res.propSarefRepresentsBaseSarefFunctionTypeSarefOnOffFunctionMultipleSarefOnOffFunction.toGraph(node, g)
	return
}

// String prints the object into a string
func (res *sSarefSwitchOnService) String() (ret string) {
	ret = res.iri + " " + "SarefSwitchOnService\n"
	ret += res.propsString()
	return
}

// propsString prints the object into a string
func (res *sSarefSwitchOnService) propsString() (ret string) {
	ret = ""
	ret += res.propSarefIsOfferedByBaseSarefDeviceTypeSarefLightSwitchMultipleSarefLightSwitch.String()
	ret += res.propSarefRepresentsBaseSarefFunctionTypeSarefOnOffFunctionMultipleSarefOnOffFunction.String()
	return
}


